<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for RgWsPublicFirmActRtUserArray ArrayType
 * @subpackage Arrays
 */
class RgWsPublicFirmActRtUserArray extends AbstractStructArrayBase
{
    /**
     * The RgWsPublicFirmActRtUser
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RgWsPublicFirmActRtUser[]
     */
    public $RgWsPublicFirmActRtUser;
    /**
     * Constructor method for RgWsPublicFirmActRtUserArray
     * @uses RgWsPublicFirmActRtUserArray::setRgWsPublicFirmActRtUser()
     * @param \StructType\RgWsPublicFirmActRtUser[] $rgWsPublicFirmActRtUser
     */
    public function __construct(array $rgWsPublicFirmActRtUser = array())
    {
        $this
            ->setRgWsPublicFirmActRtUser($rgWsPublicFirmActRtUser);
    }
    /**
     * Get RgWsPublicFirmActRtUser value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RgWsPublicFirmActRtUser[]|null
     */
    public function getRgWsPublicFirmActRtUser()
    {
        return isset($this->RgWsPublicFirmActRtUser) ? $this->RgWsPublicFirmActRtUser : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRgWsPublicFirmActRtUser method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRgWsPublicFirmActRtUser method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRgWsPublicFirmActRtUserForArrayConstraintsFromSetRgWsPublicFirmActRtUser(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $rgWsPublicFirmActRtUserArrayRgWsPublicFirmActRtUserItem) {
            // validation for constraint: itemType
            if (!$rgWsPublicFirmActRtUserArrayRgWsPublicFirmActRtUserItem instanceof \StructType\RgWsPublicFirmActRtUser) {
                $invalidValues[] = is_object($rgWsPublicFirmActRtUserArrayRgWsPublicFirmActRtUserItem) ? get_class($rgWsPublicFirmActRtUserArrayRgWsPublicFirmActRtUserItem) : sprintf('%s(%s)', gettype($rgWsPublicFirmActRtUserArrayRgWsPublicFirmActRtUserItem), var_export($rgWsPublicFirmActRtUserArrayRgWsPublicFirmActRtUserItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RgWsPublicFirmActRtUser property can only contain items of type \StructType\RgWsPublicFirmActRtUser, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RgWsPublicFirmActRtUser value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RgWsPublicFirmActRtUser[] $rgWsPublicFirmActRtUser
     * @return \ArrayType\RgWsPublicFirmActRtUserArray
     */
    public function setRgWsPublicFirmActRtUser(array $rgWsPublicFirmActRtUser = array())
    {
        // validation for constraint: array
        if ('' !== ($rgWsPublicFirmActRtUserArrayErrorMessage = self::validateRgWsPublicFirmActRtUserForArrayConstraintsFromSetRgWsPublicFirmActRtUser($rgWsPublicFirmActRtUser))) {
            throw new \InvalidArgumentException($rgWsPublicFirmActRtUserArrayErrorMessage, __LINE__);
        }
        if (is_null($rgWsPublicFirmActRtUser) || (is_array($rgWsPublicFirmActRtUser) && empty($rgWsPublicFirmActRtUser))) {
            unset($this->RgWsPublicFirmActRtUser);
        } else {
            $this->RgWsPublicFirmActRtUser = $rgWsPublicFirmActRtUser;
        }
        return $this;
    }
    /**
     * Add item to RgWsPublicFirmActRtUser value
     * @throws \InvalidArgumentException
     * @param \StructType\RgWsPublicFirmActRtUser $item
     * @return \ArrayType\RgWsPublicFirmActRtUserArray
     */
    public function addToRgWsPublicFirmActRtUser(\StructType\RgWsPublicFirmActRtUser $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RgWsPublicFirmActRtUser) {
            throw new \InvalidArgumentException(sprintf('The RgWsPublicFirmActRtUser property can only contain items of type \StructType\RgWsPublicFirmActRtUser, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RgWsPublicFirmActRtUser[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RgWsPublicFirmActRtUser|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RgWsPublicFirmActRtUser|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RgWsPublicFirmActRtUser|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RgWsPublicFirmActRtUser|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RgWsPublicFirmActRtUser|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RgWsPublicFirmActRtUser
     */
    public function getAttributeName()
    {
        return 'RgWsPublicFirmActRtUser';
    }
}
